#ifndef EICIEL_ADD_ACL_WINDOW_HPP
#define EICIEL_ADD_ACL_WINDOW_HPP

#include <gtkmm.h>
#include <vector>
#include "llista_participant.hpp"
#include "tipus_element_acl.hpp"

using namespace std;

class EicielAddACLWindow : public Gtk::Dialog
{
	public:
		static const int CANCELAR = 1;
		static const int ACCEPTAR = 0;
		EicielAddACLWindow();
		void admetDefault(bool b);
		void llistatUsuaris(vector<string>& llistat);
		void llistatGrups(vector<string>& llistat);
		void mostrarUsuaris();
		void mostrarGrups();
		bool lectura();
		bool escriptura();
		bool execucio();

		TipusElement tipusParticipant();
		vector<string> llistaParticipants();
	private:
		Gtk::RadioButton ACLusuari;
		Gtk::RadioButton ACLgrup;
		Gtk::Frame marcTipusACL;
		Gtk::RadioButton_Helpers::Group tipusACL;
		Gtk::HBox tipusACLBox;
		Gtk::VBox zonaPrincipal;
		Gtk::Frame marcParticip;
		Gtk::Frame marcPermisos;
		Gtk::TreeView vistaPartic;
		Gtk::ScrolledWindow scrollVistaPartic;
		Glib::RefPtr<Gtk::ListStore> refVistaPartic;
		Gtk::ScrolledWindow scrollVistaParticAfegits;
		Gtk::TreeView vistaParticAfegits;
		Glib::RefPtr<Gtk::ListStore> refVistaParticAfegits;
		Gtk::CheckButton aclDefault;
		Gtk::VBox zonaParticipants;
		Gtk::HButtonBox botonsParticipants;
		Gtk::HButtonBox botonsPermisos;
		Gtk::Button afegirParticipant;
		Gtk::Button eliminarParticipant;
		Gtk::CheckButton permisLectura;
		Gtk::CheckButton permisEscriptura;
		Gtk::CheckButton permisExecucio;
		Glib::RefPtr<Gdk::Pixbuf> iconaUsuariACL;
		Glib::RefPtr<Gdk::Pixbuf> iconaGrupACL;
		ModelLlistaParticipant modelPartic;
		//ModelLlistaParticipant modelParticAfegits;
		vector<string> llUsuaris;
		vector<string> llGrups;
		Gtk::Button* botoAcceptar;

		int numParticipantsAfegits;

		void mostrarParticipants(vector<string>& v, Glib::RefPtr<Gdk::Pixbuf> icona);
		void canviDeSeleccioPartic();
		void canviDeSeleccioParticAfegit();
		void afegeixParticipant();
		void eliminaParticipant();
		int ordenaParticipants(const Gtk::TreeModel::iterator& i, const Gtk::TreeModel::iterator& j);
};

#endif
