#include <iostream>
#include "eiciel_main_window.hpp"
#include "config.hpp"

// Constructor
EicielWindow::EicielWindow(EicielMainControler* cont) 
	: obrirFitxer(Gtk::Stock::OPEN),
	botonera_dreta(Gtk::BUTTONBOX_START, 2),
	botonera_inferior(Gtk::BUTTONBOX_END, 2),
	afegirACL(Gtk::Stock::ADD), 
	modificarACLDefault("Per defecte"),
	eliminarACL(Gtk::Stock::REMOVE),
	quantA("Quant a..."),
	ajuda(Gtk::Stock::HELP),
	controlador(cont), // Assignem el controlador a la finestra
	sortir(Gtk::Stock::QUIT)
{
	// Assignem la finestra al controlador
	controlador->finestra = this;
	
	// Posem la mida de les vores a 4
	set_title("Eiciel");
	set_border_width(4);


	// VBOX - Part principal
	add(zona_principal);
	zona_principal.set_spacing(4);

	// HBOX - Part superior
	zona_principal.add(zona_superior);

	zona_superior.set_spacing(4);
	zona_superior.add(nomFitxer);
	zona_superior.add(obrirFitxer);


	// Zona inferior
	zona_principal.add(marc_inferior);


	marc_inferior.set_label("ACL");
	marc_inferior.set_size_request(-1, 400);
	marc_inferior.set_border_width(4);

	// Obrim les icones
	iconaUsuari = Gdk::Pixbuf::create_from_file(DATADIR "/img/usuari.png");
	iconaUsuariACL = Gdk::Pixbuf::create_from_file(DATADIR "/img/usuari-acl.png");
	iconaGrup = Gdk::Pixbuf::create_from_file(DATADIR "/img/grup.png");
	iconaGrupACL = Gdk::Pixbuf::create_from_file(DATADIR "/img/grup-acl.png");
	iconaAltres = Gdk::Pixbuf::create_from_file(DATADIR "/img/altres.png");
	iconaMascara = Gdk::Pixbuf::create_from_file(DATADIR "/img/mascara.png");

	iconaDefaultUsuari = Gdk::Pixbuf::create_from_file(DATADIR "/img/usuari-default.png");
	iconaDefaultGrup = Gdk::Pixbuf::create_from_file(DATADIR "/img/grup-default.png");
	iconaDefaultAltres = Gdk::Pixbuf::create_from_file(DATADIR "/img/altres-default.png");
	iconaDefaultUsuariACL = Gdk::Pixbuf::create_from_file(DATADIR "/img/usuari-acl-default.png");
	iconaDefaultGrupACL = Gdk::Pixbuf::create_from_file(DATADIR "/img/grup-acl-default.png");
	iconaDefaultMascara = Gdk::Pixbuf::create_from_file(DATADIR "/img/mascara-default.png");

	// Resta de la llista

	refLlistaACL = Gtk::ListStore::create(modelLlistaACL);

	// Gtk::TreeModel::iterator iter = refLlistaACL->append();
	// Gtk::TreeModel::Row row(*iter);
	// row[modelLlistaACL.iconeta] = iconaUsuari;
	// row[modelLlistaACL.nomEntrada] = "Propietari";
	// row[modelLlistaACL.permisLectura] = true;
	// row[modelLlistaACL.permisEscriptura] = false;
	// row[modelLlistaACL.permisExecucio] = true;
	// row[modelLlistaACL.esborrable] = false;

	// iter = refLlistaACL->append();
	// row = *iter;
	// row[modelLlistaACL.iconeta] = iconaUsuariACL;
	// row[modelLlistaACL.nomEntrada] = "cvs";
	// row[modelLlistaACL.permisLectura] = false;
	// row[modelLlistaACL.permisEscriptura] = true;
	// row[modelLlistaACL.permisExecucio] = false;
	// row[modelLlistaACL.esborrable] = true;

	// iter = refLlistaACL->append();
	// row = *iter;
	// row[modelLlistaACL.iconeta] = iconaGrup;
	// row[modelLlistaACL.nomEntrada] = "Grup";
	// row[modelLlistaACL.permisLectura] = false;
	// row[modelLlistaACL.permisEscriptura] = false;
	// row[modelLlistaACL.permisExecucio] = false;
	// row[modelLlistaACL.esborrable] = true;

	// iter = refLlistaACL->append();
	// row = *iter;
	// row[modelLlistaACL.iconeta] = iconaGrupACL;
	// row[modelLlistaACL.nomEntrada] = "adm";
	// row[modelLlistaACL.permisLectura] = true;
	// row[modelLlistaACL.permisEscriptura] = true;
	// row[modelLlistaACL.permisExecucio] = true;
	// row[modelLlistaACL.esborrable] = true;

	// iter = refLlistaACL->append();
	// row = *iter;
	// row[modelLlistaACL.iconeta] = iconaMascara;
	// row[modelLlistaACL.nomEntrada] = Glib::locale_to_utf8("Mscara");
	// row[modelLlistaACL.permisLectura] = false;
	// row[modelLlistaACL.permisEscriptura] = false;
	// row[modelLlistaACL.permisExecucio] = false;
	// row[modelLlistaACL.esborrable] = true;

	// iter = refLlistaACL->append();
	// row = *iter;
	// row[modelLlistaACL.iconeta] = iconaAltres;
	// row[modelLlistaACL.nomEntrada] = "Altres";
	// row[modelLlistaACL.permisLectura] = false;
	// row[modelLlistaACL.permisEscriptura] = false;
	// row[modelLlistaACL.permisExecucio] = false;
	// row[modelLlistaACL.esborrable] = true;

	vistaLlistaACL.set_reallocate_redraws();
	vistaLlistaACL.set_model(refLlistaACL);
	vistaLlistaACL.append_column("", modelLlistaACL.iconeta);
	vistaLlistaACL.append_column("Entrada", modelLlistaACL.nomEntrada);
	vistaLlistaACL.append_column_editable("Lectura", modelLlistaACL.permisLectura);
	vistaLlistaACL.append_column_editable("Escriptura", modelLlistaACL.permisEscriptura);
	vistaLlistaACL.append_column_editable("Execucio", modelLlistaACL.permisExecucio);

	marc_inferior.add(columna_inferior);
	vistaLlistaACL.set_size_request();
	
	contenidorVistaLlistaACL.add(vistaLlistaACL);
	contenidorVistaLlistaACL.set_policy(Gtk::POLICY_NEVER, Gtk::POLICY_AUTOMATIC);

	columna_inferior.set_spacing(4);
	columna_inferior.add(contenidorVistaLlistaACL);
	columna_inferior.add(botonera_dreta);

	botonera_dreta.add(afegirACL);
	botonera_dreta.add(eliminarACL);
	botonera_dreta.add(modificarACLDefault);

	zona_principal.add(botonera_inferior);

	botonera_inferior.add(sortir);
	botonera_inferior.add(ajuda);
	botonera_inferior.add(quantA);

	// Vinculaci dels senyals
	// Canvi de sellecci
	Glib::RefPtr<Gtk::TreeSelection> referenciaSeleccioLlista = vistaLlistaACL.get_selection();
	referenciaSeleccioLlista->signal_changed().connect(
			SigC::slot(*this, &EicielWindow::canviDeSeleccio)
			);
	// Funci de filtre
	referenciaSeleccioLlista->set_select_function( 
			SigC::slot(*this, &EicielWindow::funcioSeleccio) 
			);

	// Boto d'obrir fitxer
	obrirFitxer.signal_clicked().connect(
			SigC::slot(*controlador, &EicielMainControler::oberturaFitxer)
			);

	// Boto de sortir
	sortir.signal_clicked().connect(
			SigC::slot(*controlador, &EicielMainControler::sortidaAplicacio)
			);

	// Boto d'eliminar un ACL
	eliminarACL.signal_clicked().connect(
			SigC::slot(*this, &EicielWindow::eliminarACLSeleccionada)
			);

	// Boto d'afegir un ACL
	afegirACL.signal_clicked().connect(
			SigC::slot(*controlador, &EicielMainControler::afegirACL)
			);

	// Detectar un canvi de default ACL
	modificarACLDefault.signal_clicked().connect (
			SigC::slot(*controlador, &EicielMainControler::canviACLDefault)
			);

	// Detectar una edici de la columna 
	Gtk::TreeViewColumn* col = vistaLlistaACL.get_column(2);
	Gtk::CellRenderer* render = col->get_first_cell_renderer(); // Nomes tenim un
	Gtk::CellRendererToggle* toggle_render = dynamic_cast<Gtk::CellRendererToggle*>(render);

	toggle_render->signal_toggled().connect(
			SigC::slot(*this, &EicielWindow::canviPermisos)
			);

	col = vistaLlistaACL.get_column(3);
	render = col->get_first_cell_renderer();
	toggle_render = dynamic_cast<Gtk::CellRendererToggle*>(render);

	toggle_render->signal_toggled().connect(
			SigC::slot(*this, &EicielWindow::canviPermisos)
			);

	col = vistaLlistaACL.get_column(4);
	render = col->get_first_cell_renderer();
	toggle_render = dynamic_cast<Gtk::CellRendererToggle*>(render);

	toggle_render->signal_toggled().connect(
			SigC::slot(*this, &EicielWindow::canviPermisos)
			);

	noHiHaFitxer();
	noHiHaSeleccio();

	show_all_children();
}

EicielWindow::~EicielWindow()
{
}

void EicielWindow::noHiHaFitxer()
{
	marc_inferior.set_sensitive(false);
	nomFitxer.set_text("No hi ha cap fitxer obert");
}

void EicielWindow::buidaLlistaACL()
{
	refLlistaACL->clear();
}

void EicielWindow::canviDeSeleccio()
{
	Glib::RefPtr<Gtk::TreeSelection> referenciaSeleccioLlista = vistaLlistaACL.get_selection();
	Gtk::TreeModel::iterator iter = referenciaSeleccioLlista->get_selected();
	if (!iter)
	{
		noHiHaSeleccio();
	}
	else
	{
		hiHaSeleccio();
	}
}

void EicielWindow::eliminarACLSeleccionada()
{
	Glib::RefPtr<Gtk::TreeSelection> referenciaSeleccioLlista = vistaLlistaACL.get_selection();
	Gtk::TreeModel::iterator iter = referenciaSeleccioLlista->get_selected();
	if (iter)
	{
		Gtk::TreeModel::Row row(*iter);
		controlador->eliminarACL(Glib::ustring(row[modelLlistaACL.nomEntrada]), TipusElement(row[modelLlistaACL.tipusEntrada]));
	}
}

bool EicielWindow::funcioSeleccio(const Glib::RefPtr<Gtk::TreeModel>& model,
		const Gtk::TreeModel::Path& path, bool)
{
	const Gtk::TreeModel::iterator iter = model->get_iter(path);
	return (*iter)[modelLlistaACL.esborrable];
}

void EicielWindow::noHiHaSeleccio()
{
	eliminarACL.set_sensitive(false);
}

void EicielWindow::hiHaSeleccio()
{
	eliminarACL.set_sensitive(true);
}

void EicielWindow::afegeixNoSeleccionable(string titol, 
		bool lectura, bool escriptura, bool execucio, TipusElement e)
{
	Gtk::TreeModel::iterator iter = refLlistaACL->append();
	Gtk::TreeModel::Row row(*iter);
	row = *iter;
	afegeixElement(titol, lectura, escriptura, execucio, e, row);
	row[modelLlistaACL.esborrable] = false;
}

void EicielWindow::afegeixSeleccionable(string titol, 
		bool lectura, bool escriptura, bool execucio, TipusElement e)
{
	Gtk::TreeModel::iterator iter = refLlistaACL->append();
	Gtk::TreeModel::Row row(*iter);

	afegeixElement(titol, lectura, escriptura, execucio, e, row);
	row[modelLlistaACL.esborrable] = true;
}

void EicielWindow::afegeixElement(string titol, bool lectura, bool escriptura, bool execucio,
		TipusElement e, Gtk::TreeModel::Row& row)
{
	row[modelLlistaACL.tipusEntrada] = e;
	row[modelLlistaACL.iconeta] = retornaIconaApropiada(e);
	row[modelLlistaACL.nomEntrada] = Glib::locale_to_utf8(titol);
	row[modelLlistaACL.permisLectura] = lectura;
	row[modelLlistaACL.permisEscriptura] = escriptura;
	row[modelLlistaACL.permisExecucio] = execucio;
}

Glib::RefPtr<Gdk::Pixbuf> EicielWindow::retornaIconaApropiada(TipusElement e)
{
	switch(e)
	{
		case USUARI : 
			return iconaUsuari;
		case GRUP :
			return iconaGrup;
		case ALTRES :
			return iconaAltres;
		case MASCARA :
			return iconaMascara;
		case ACL_USUARI : 
			return iconaUsuariACL;
		case ACL_GRUP :
			return iconaGrupACL;
		case DEFAULT_USUARI :
			return iconaDefaultUsuari;
		case DEFAULT_GRUP :
			return iconaDefaultGrup;
		case DEFAULT_ALTRES :
			return iconaDefaultAltres;
		case DEFAULT_ACL_USUARI :
			return iconaDefaultUsuariACL;
		case DEFAULT_ACL_GRUP :
			return iconaDefaultGrupACL;
		case DEFAULT_MASCARA :
			return iconaDefaultMascara;
		default :
			return iconaAltres;
	}
}

void EicielWindow::establirNomFitxer(string nomF)
{
	nomFitxer.set_text(Glib::filename_to_utf8(nomF));
	marc_inferior.set_sensitive(true);
}

void EicielWindow::canviPermisos(const Glib::ustring& cadena)
{

	Gtk::TreeModel::iterator i = refLlistaACL->get_iter(cadena);
	Gtk::TreeModel::Row row(*i);
	controlador->actualitzaEntradaACL(row[modelLlistaACL.tipusEntrada], 
			Glib::ustring(row[modelLlistaACL.nomEntrada]), row[modelLlistaACL.permisLectura],
			row[modelLlistaACL.permisEscriptura], row[modelLlistaACL.permisExecucio]);
}

void EicielWindow::activarBotoDefaultACL(bool b)
{
	modificarACLDefault.set_sensitive(b);
}

void EicielWindow::hiHaDefaultACL(bool b)
{
	modificarACLDefault.set_active(b);
}

bool EicielWindow::donaACLDefault()
{
	return modificarACLDefault.get_active();
}
